/*
 * ppmtocm.c - convert a portable pixmap to a portable graymap *
 * 
 * Copyright (C) 1989 by Jef Poskanzer. *
 * Copyright (C) 1991 by Burkhard Neidecker-Lutz
 * 
 * Permission to use, copy, modify, and distribute this software and its *
 * documentation for any purpose and without fee is hereby granted, provided *
 * that the above copyright notice appear in all copies and that both that *
 * copyright notice and this permission notice appear in supporting *
 * documentation.  This software is provided "as is" without express or *
 * implied warranty.
 */

#include "ppm.h"
#include "pgm.h"

int main(argc, argv)
int             argc;
char           *argv[];
{
  FILE           *ifp;
  pixel          *pixelrow;
  register pixel *pP;
  gray           *grayrow;
  register gray  *gP;
  int             rows, cols, format, row;
  register int    col;
  int r,g,b;
  pixval          maxval;

  ppm_init(&argc, argv);

  if (argc > 2)
    pm_usage("[ppmfile]");

  if (argc == 2)
    ifp = pm_openr(argv[1]);
  else
    ifp = stdin;

  ppm_readppminit(ifp, &cols, &rows, &maxval, &format);
  pgm_writepgminit(stdout, cols, rows, maxval, 0);
  pixelrow = ppm_allocrow(cols);
  grayrow = pgm_allocrow(cols);

  for (row = 0; row < rows; row++) {
    ppm_readppmrow(ifp, pixelrow, cols, maxval, format);
      for (col = 0, pP = pixelrow, gP = grayrow;
	   col < cols;
	   col++, pP++, gP++) {
	   r = PPM_GETR(*pP);
	   g = PPM_GETG(*pP);
	   b = PPM_GETB(*pP);
	   *gP = (gray) (r/63)*25 + (g/63)*5 + b/63;
      }
    pgm_writepgmrow(stdout, grayrow, cols, maxval, 0);
  }

  pm_close(ifp);

  return(0);
}
