#include <stdio.h>
#include <stdlib.h>

int getlong(p)
unsigned char *p;
{
 return(p[0] + (p[1]<<8) + (p[2]<<16) + (p[3]<<24));
}

void assignlong(p,v)
unsigned char *p;
long v;
{
  p[0] = v & 0xff;
  p[1] = (v>>8) & 0xff;
  p[2] = (v>>16) & 0xff;
  p[3] = (v>>24) & 0xff;
}

int main(argc, argv)
int   argc;
char  *argv[];
{
  int           top;		/* size of directory */
  unsigned char  *entry;	/* list of directory entries */
  char           *glfile;
  FILE           *fp;		/* gl file */
  FILE           *newfp;	/* opened for each extracted file */
  int             num_ents = 0;	/* number of files to extract */
  int             i;
  long            rsize;	/* Size of current file */
  char            buff[1024];
  /* For referencing fileds in entry table: */
  unsigned char  *bignum;
  unsigned char  *name;


  if (argc != 2) {
    fprintf(stderr, "ungl <glfile>\n");
    exit(1);
  } else {
    glfile = argv[1];
  }

  fp = fopen(glfile, "r");
  if (fp == NULL) {
    printf("couldn't open file %s\n", glfile);
    exit(1);
  }

  top = (0xff &getc(fp));
  top += (0xff & getc(fp))<<8;
  entry = (unsigned char *) malloc(top);

  /* Read in directory */
  fread(entry, top, 1, fp);
  num_ents = top / 17 - 1;

  /* Get file size */
  /* Put it in last (zeroed) directory entry, for easy algorithm */
  fseek(fp, 0L, 2);
  bignum = &entry[num_ents * 17];
  assignlong(bignum,ftell(fp));

  /* Go to first file */
  bignum = entry;
  fseek(fp, getlong(bignum) + 4, 0);

  /* Extract each file */
  for (name = entry + 4, i = 0; i < num_ents;
       i++, name += 17, bignum = (name - 4)) {
    newfp = fopen((char*) name, "w");
    /* File size if address of next file (or end) minus this address */
    rsize = getlong(bignum + 17) - getlong(bignum);

    /* Copy file, one "block" at a time */
    while (rsize > sizeof(buff)) {
      fread(buff, sizeof(buff), 1, fp);
      fwrite(buff, sizeof(buff), 1, newfp);
      rsize -= sizeof(buff);
    }
    fread(buff, rsize, 1, fp);
    fwrite(buff, rsize, 1, newfp);
    fclose(newfp);
  }
  fclose(fp);
  free(entry);
  return(0);
}
